/*Testing e_it RRA correlation to test RRA endogeneity in the income process equation (static, levels)*/

  *Generate log of RRA parameter
  gen lR=ln(RRA0_c)
  
 /*controls*/
  gen figlio05=nfigli05>0&nfigli==1
  gen figli411=nfigli411>0
  gen nfigli415=nfigli411+nfigli1215
  gen annimatr=ln(anno-anconv)
  gen selfempl=kb2==1
tab area5, gen(area_)
tab studio, gen (educ)
tab stupcf, gen (peduc)
tab stumcf, gen (meduc)
gen d=ln(abs(anamcf-anapcf))

*IV estimation, endogenous RRA
  qui ivreg2 ly0_h nperc studio sex  area_1-area_4 exp exp2 sett_1 sett_2 sett_4 qual_1-qual_3 pubblico selfempl married (lR = nfigli03 meduc5 d) [aw = peso] if anno==2010 & eta<58, endog(lR)  first ffirst savefirst
  est sto iv
 *OLS estimation
  qui reg ly0_h lR nperc studio sex  area_1-area_4 exp exp2 sett_1 sett_2 sett_4 qual_1-qual_3 pubblico selfempl married [aw = peso] if anno==2010 & eta<58 & e(sample)
  est sto ols 
  
  hausman iv ols, cons
  
   /*
	qui reg lR  nfigli03 meduc5 d nperc studio sex  area_1-area_4 exp exp2 sett_1 sett_2 sett_4 qual_1-qual_3 pubblico selfempl  married if anno==2010 & e(sample) [aw=peso]
		test  nfigli03 meduc5 d
		cap drop lR_hat v
		predict lR_hat, xb
		cap drop v
		predict v, res
		qui reg ly0_h lR  v  nperc studio sex  area_1-area_4 exp exp2 sett_1 sett_2 sett_4 qual_1-qual_3 pubblico selfempl married [aw = peso] if anno==2010 & e(sample)/*,  robust*/
		est sto twosls
		test v
	*/	

/*Two endogenous vars: RRA and Education*/
  ivreg2 ly0_h  nperc sex  area_1-area_4 exp exp2 sett_2 sett_4 qual_1-qual_3 pubblico selfempl married (lR studio= nfigli03 meduc5 d stupcf stumcf) [aw = peso] if anno==2010 & eta<58, endog(lR studio)  first ffirst savefirst
  est sto iv2
   
 cd "${path}/shiw/output"
********Table IV:************************************************* 
*****Endogeneity analysis of RRA w.r.t the household income process
*******************************************************************
esttab  ols iv iv2 using table_IV.txt, replace se(4) b(3) indicate(controls= nperc sex  area_* exp exp2 sett_* qual_* pubblico selfempl married ) star(* 0.1 ** 0.05 *** 0.01) ///
stats(r2 N cdf sarganp estatp, labels("R_sq" "N. of cases" "F test of excluded instruments" "Sargan p-val" "Endogeneity t. p-val")) legend ///
varlabels(_cons Constant) posthead("") prefoot("") postfoot("") varwidth(16) style(fixed)
cd "${path}/shiw/data"


